SystemOrganization addCategory: #'Poll-Commands'!
SystemOrganization addCategory: #'Poll-Model'!
SystemOrganization addCategory: #'Poll-Visitor'!
SystemOrganization addCategory: #'Poll-View'!

PREditCommand subclass: #POEditPollCommand
	instanceVariableNames: 'options'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POEditPollCommand class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 20:19'!
descriptionOptions
	^POPoll descriptionOptions ! !

!POEditPollCommand class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 20:06'!
descriptionTitle
	^POPoll descriptionTitle! !

!POEditPollCommand class methodsFor: 'testing' stamp: 'pmm 12/18/2005 20:06'!
isAbstract
	^false! !

!POEditPollCommand class methodsFor: 'accessing' stamp: 'pmm 1/29/2006 11:40'!
structureClass
	^POPoll! !

!POEditPollCommand methodsFor: 'events' stamp: 'pmm 12/18/2005 20:21'!
doExecute
	super doExecute.
	self structure options: self options.! !

!POEditPollCommand methodsFor: 'events' stamp: 'pmm 12/23/2005 00:02'!
doInitialize
	super doInitialize.
	self options: self structure options! !

!POEditPollCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:21'!
options
	^options! !

!POEditPollCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 20:21'!
options: aCollection 
	options := aCollection! !

!PRVisitor methodsFor: '*Poll' stamp: 'pmm 12/18/2005 17:07'!
visitPoll: aPoll
	self visitStructure: aPoll! !

PRCommand subclass: #POVoteCommand
	instanceVariableNames: 'vote'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Commands'!

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:28'!
hasAlreadyVoted
	| cookies poll |
	cookies := WACurrentSession value currentRequest cookies.
	poll := PRCurrentContext value structure.
	^(cookies includesKey: poll cookieName)! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 12/22/2005 16:21'!
isAbstract
	^false! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^WACurrentSession value notNil! !

!POVoteCommand class methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:26'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ self isHttp not or: [ self hasAlreadyVoted not ] ]! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:28'!
label
	^'Vote'! !

!POVoteCommand class methodsFor: 'accessing' stamp: 'pmm 1/29/2006 11:41'!
structureClass
	^POPoll ! !

!POVoteCommand methodsFor: 'private' stamp: 'pmm 2/10/2006 19:43'!
addCookie
	| voteCookie |
	voteCookie := (WACookie
		key: self structure cookieName
		value: self vote text)
		expiry: (DateAndTime year: 2095 month: 1 day: 1 hour: 12 minute: 0);
		yourself.
	self session redirectWithCookies: (Array with: voteCookie)! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
description
	^super description copy
		add: self descriptionVote;
		yourself! !

!POVoteCommand methodsFor: 'accessing-description' stamp: 'pmm 12/22/2005 16:38'!
descriptionVote
	^(MASingleOptionDescription selector: #vote label: 'Vote' priority: 200)
		options: self options;
		reference: (POPollOption description
			stringWriter: POLabelWriter;
			yourself);
		componentClass: MARadioGroupComponent;
		beRequired;
		yourself! !

!POVoteCommand methodsFor: 'events' stamp: 'pmm 1/28/2006 10:23'!
doExecute
	super doExecute.
	self vote addVote.
	self isHttp
		ifTrue: [ self addCookie ]! !

!POVoteCommand methodsFor: 'testing' stamp: 'pmm 1/28/2006 10:24'!
isHttp
	^self class isHttp ! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:29'!
options
	^self structure options! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 20:13'!
session
	^WACurrentSession value! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 12/18/2005 16:36'!
vote
	^vote! !

!POVoteCommand methodsFor: 'accessing' stamp: 'pmm 2/10/2006 19:42'!
vote: aPollOption 
	vote := aPollOption! !

MAStringWriter subclass: #POLabelWriter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Visitor'!

!POLabelWriter methodsFor: 'visiting' stamp: 'pmm 12/22/2005 16:27'!
write: anObject description: aDescription
	^anObject label! !

PRObject subclass: #POPollOption
	instanceVariableNames: 'text votes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionText
	^(MAStringDescription selector: #text label: 'Text' priority: 100)
		beRequired;
		yourself! !

!POPollOption class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 15:42'!
descriptionVotes
	^(MANumberDescription selector: #votes label: 'Votes' priority: 200)
		default: 0;
		beHidden;
		yourself! !

!POPollOption class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:39'!
isAbstract
	^false! !

!POPollOption methodsFor: 'actions' stamp: 'pmm 12/22/2005 16:45'!
addVote
	self votes: self votes + 1! !

!POPollOption methodsFor: 'testing' stamp: 'pmm 2/10/2006 20:12'!
hasVotes
	^self votes isZero not! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/22/2005 16:28'!
label
	^self text! !

!POPollOption methodsFor: 'printing' stamp: 'pmm 12/22/2005 16:34'!
printOn: aStream
	super printOn: aStream.
	self text isNil ifFalse: [
		aStream
			nextPut: $(;
			nextPutAll: self text;
			nextPut: $) ]! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
text
	^text! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
text: aString 
	text := aString! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:38'!
votes
	^votes! !

!POPollOption methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:43'!
votes: anInteger 
	votes := anInteger! !

PRStructure subclass: #POPoll
	instanceVariableNames: 'options uuid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 2/10/2006 20:11'!
descriptionOptions
	^(MAToManyRelationDescription selector: #options label: 'Options' priority: 200)
		classes: (Array with: POPollOption);
		default: OrderedCollection new;
		yourself.! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 12/18/2005 16:37'!
descriptionTitle
	^super descriptionTitle
		label: 'Question';
		yourself! !

!POPoll class methodsFor: 'accessing-description' stamp: 'pmm 1/28/2006 10:04'!
descriptionUUID
	^ (MAStringDescription selector: #uuid label: 'UUId' priority: 1000)
		beHidden;
		beReadonly;
		yourself.! !

!POPoll class methodsFor: 'testing' stamp: 'pmm 12/18/2005 15:45'!
isAbstract
	^false! !

!POPoll class methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:48'!
label
	^'Poll'! !

!POPoll methodsFor: 'visiting' stamp: 'pmm 12/18/2005 17:08'!
accept: aVisitor
	aVisitor visitPoll: self.! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:20'!
cookieName
	^'pierPoll' , self uuid! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/29/2006 11:36'!
editCommandClass
	^POEditPollCommand! !

!POPoll methodsFor: 'initialize-release' stamp: 'pmm 1/28/2006 10:03'!
initialize
	super initialize.
	uuid := UUID new printString.
	self options: OrderedCollection new! !

!POPoll methodsFor: 'testing' stamp: 'pmm 2/10/2006 20:22'!
isValidView: aComponentClass in: aContext
	^(super isValidView: aComponentClass in: aContext)
		and: [ aComponentClass ~= PRDefaultView  ]
		and: [ (aComponentClass inheritsFrom: PRDefaultView) not ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options
	^options! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:44'!
options: aCollection 
	options := aCollection! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 12/18/2005 15:45'!
totalVotes
	^self options inject: 0 into: [ :sum :each |
		sum + each votes ]! !

!POPoll methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:02'!
uuid
	^uuid! !

!POPoll methodsFor: 'accessing-commands' stamp: 'pmm 2/10/2006 21:49'!
viewComponentClass
	^POCanvasPollResultsView! !

PRViewComponent subclass: #POPollResultsView
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

POPollResultsView subclass: #POCanvasPollResultsView
	instanceVariableNames: 'chart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 16:44'!
isAbstract
	^false! !

!POCanvasPollResultsView class methodsFor: 'testing' stamp: 'pmm 12/18/2005 17:07'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]! !

!POCanvasPollResultsView class methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:50'!
label
	^'View Results (Canvas)'! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 21:50'!
chart
	^chart! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:12'!
chart: anObject
	chart := anObject! !

!POCanvasPollResultsView methodsFor: 'accessing' stamp: 'pmm 12/22/2005 17:13'!
children
	^Array with: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:14'!
createPieChart
	self chart: CGPieChart new.
	self chart addDataset: self dataset.
	self chart xLabels: self xLabels.
	self chart fontSize: 12.
	self chart labelWidth: 100.
	self chart width: self chartWidth height: self chartHeight.
	self chart paddingTop: 50 left: 50 bottom: 50 right: 50.
	self chart id: 'result' , self poll title! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 1/3/2006 10:14'!
dataset
	| index data |
	index := 0.
	data := self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		Array with: index with: each votes ].
	^CGDataset name: self poll title data: data! !

!POCanvasPollResultsView methodsFor: 'initialize-release' stamp: 'pmm 12/22/2005 21:50'!
initialize
	super initialize.
	self createPieChart! !

!POCanvasPollResultsView methodsFor: 'rendering' stamp: 'pmm 12/22/2005 17:17'!
renderContentOn: html
	html render: self chart! !

!POCanvasPollResultsView methodsFor: 'private' stamp: 'pmm 1/3/2006 10:14'!
xLabels
	| index labels |
	labels := Dictionary new.
	index := 0.
	self pollOptionsWithVotes collect: [ :each |
		index := index + 1.
		labels at: index put: each text ].
	^labels! !

POPollResultsView subclass: #POMorphPollResultsView
	instanceVariableNames: 'morph morphUrl'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-View'!

!POMorphPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/10/2006 21:57'!
isAbstract
	^false! !

!POMorphPollResultsView class methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:59'!
label
	^'View Results (Morph)'! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:14'!
createMorph
	| values |
	values := self pollOptionValues.
	morph := PCPieChartMorph values: values.
	morph extent: self chartWidth @ self chartHeight.
	morph colors: (Color wheel: values size saturation: 0.25 brightness: 1).
	morph references: self pollOptionLabels.
	morph showLabels! !

!POMorphPollResultsView methodsFor: 'initialize-release' stamp: 'pmm 2/10/2006 23:12'!
initialize
	super initialize.
	self createMorph. ! !

!POMorphPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:28'!
morphUrlIn: html
	morphUrl isNil ifTrue: [
		morphUrl := html context urlForDocument: morph mimeType: 'image/gif' ].
	^morphUrl! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 23:27'!
pollOptionLabels
	| amount |
	amount := self pollOptionsWithVotes inject: 0 into: [ :sum : each | sum + each votes ].
	^self pollOptionsWithVotes collect: [ :each |
		String streamContents: [ :stream |
			stream
				nextPutAll: each text;
				nextPutAll: ' (';
				nextPutAll: (100 * each votes // amount) displayString;
				nextPutAll: '%)' ] ]! !

!POMorphPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 22:49'!
pollOptionValues
	^self pollOptionsWithVotes collect: [ :each | each votes ]! !

!POMorphPollResultsView methodsFor: 'rendering' stamp: 'pmm 2/10/2006 23:17'!
renderContentOn: html
	html image
		width: self chartWidth;
		height: self chartHeight;
		altText: 'poll results';
		url: (self morphUrlIn: html)! !

!POPollResultsView class methodsFor: 'testing' stamp: 'pmm 2/10/2006 21:58'!
isValidIn: aContext
	^(super isValidIn: aContext)
		and: [ aContext structure isKindOf: POPoll ]! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartHeight
	^400! !

!POPollResultsView methodsFor: 'private' stamp: 'pmm 2/10/2006 23:13'!
chartWidth
	^400! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 23:20'!
pierContext
	^PRCurrentContext value! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 23:20'!
poll
	^self pierContext structure! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptions
	^self poll options! !

!POPollResultsView methodsFor: 'accessing' stamp: 'pmm 2/10/2006 21:55'!
pollOptionsWithVotes
	^self pollOptions select: [ :each | each hasVotes ]! !

!POPollResultsView methodsFor: 'rendering' stamp: 'pmm 2/10/2006 21:56'!
rendererClass
	^WARenderCanvas ! !

MADistribution subclass: #P0Distribution
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Poll-Model'!

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
package
	"The SqueakMap package name."

	^ 'Poll'! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 09:59'!
packages
	^ #( ( 'Poll' ) )! !

!P0Distribution class methodsFor: 'accessing' stamp: 'pmm 1/28/2006 10:00'!
version
	"The first item is the product name, which should only contain lowercase letters. Then the version numbers are following, that are made up of three numbers. An optimal suffix alpha, beta, pre or rc follows. External packages or extensions might want to call this method to check the version required to run."

	^ #( poll 0 9 0 pre1 )! !
